﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.StorageClient;
using Microsoft.WindowsAzure.ServiceRuntime;

namespace Chapter16.AzureStorageRole
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

            Contact NewContact = new Contact();
            NewContact.PartitionKey = "";
            NewContact.RowKey = Guid.NewGuid().ToString();
            NewContact.Firstname = "Alex";
            NewContact.Lastname = "Mackey";

          

         
            //var storageAccount = CloudStorageAccount.SetConfigurationSettingPublisher((configName, configSetter) =>
            //       {
            //           // Provide the configSetter with the initial value
            //           configSetter(RoleEnvironment.GetConfigurationSettingValue(configName));
            //       });


            //ctx.AddObject("Contacts", NewContact);
            //ctx.SaveChanges();


            this.submitButton.Click += new EventHandler(submitButton_Click);
            bindImages();


        }

        void submitButton_Click(object sender, EventArgs e)
        {
            CloudStorageAccount.SetConfigurationSettingPublisher((configName, configSetter) =>
            {
                // Provide the configSetter with the initial value
                configSetter(RoleEnvironment.GetConfigurationSettingValue(configName));
            });


            var storageAccount = CloudStorageAccount.FromConfigurationSetting("DataConnectionString");

            CloudBlobClient blobStorage = storageAccount.CreateCloudBlobClient();
            CloudBlobContainer container = blobStorage.GetContainerReference("blobs");

            var name = string.Format("{0:10}_{1}", DateTime.Now.Ticks, Guid.NewGuid());

            container.CreateIfNotExist();

            var permissions = container.GetPermissions();

            permissions.PublicAccess = BlobContainerPublicAccessType.Container;
            container.SetPermissions(permissions);

            container.GetBlockBlobReference(name).UploadFromStream(upload.FileContent);


        
        }

        public void bindImages()
        {
            CloudStorageAccount.SetConfigurationSettingPublisher((configName, configSetter) =>
            {
                // Provide the configSetter with the initial value
                configSetter(RoleEnvironment.GetConfigurationSettingValue(configName));
            });

            var storageAccount = CloudStorageAccount.FromConfigurationSetting("DataConnectionString");

            CloudBlobClient blobStorage = storageAccount.CreateCloudBlobClient();
            CloudBlobContainer container = blobStorage.GetContainerReference("blobs");

           // var query=container.ListBlobs();

            thumbnails.DataSource = from o in container.ListBlobs()
                                    select new { Url = o.Uri };
            thumbnails.DataBind();
        }

        public void QueueTest()
        {
            CloudStorageAccount.SetConfigurationSettingPublisher((configName, configSetter) =>
            {
                // Provide the configSetter with the initial value
                configSetter(RoleEnvironment.GetConfigurationSettingValue(configName));
            });


            var storageAccount = CloudStorageAccount.FromConfigurationSetting("DataConnectionString");

            //CloudBlobClient blobStorage = storageAccount.CreateCloudBlobClient();
            // CloudBlobContainer container = blobStorage.GetContainerReference("photogallery");

            CloudQueueClient queueStorage = storageAccount.CreateCloudQueueClient();
            CloudQueue queue = queueStorage.GetQueueReference("test");
            queue.CreateIfNotExist();

            CloudQueueMessage message = new CloudQueueMessage("hello");

            queue.AddMessage(message);

            CloudQueueMessage readMessage = queue.GetMessage();
        }

    }
}