﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.ServiceRuntime;
using Microsoft.WindowsAzure.StorageClient;

namespace WebRole1
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            this.cmdUpload.Click += new EventHandler(cmdUpload_Click);
            bindImages();

            ////create the table(s)
            //var storageAccount = CloudStorageAccount.FromConfigurationSetting("DataConnectionString");
            //var tableStorage = storageAccount.CreateCloudTableClient();
            //tableStorage.CreateTableIfNotExist("SharpcloudTable");


            ////to use the datacontext and query table
            //storageAccount = CloudStorageAccount.FromConfigurationSetting("DataConnectionString");
            //AzureDataServiceContext svc = new AzureDataServiceContext(storageAccount.TableEndpoint.ToString(), storageAccount.Credentials);
            //var res = svc.SharpcloudTable.Where(st => st.PartitionKey == "hello").ToList();

       }

        void cmdUpload_Click(object sender, EventArgs e)
        {
            CloudStorageAccount.SetConfigurationSettingPublisher((configName, configSetter) =>
            {
                // Provide the configSetter with the initial value
                configSetter(RoleEnvironment.GetConfigurationSettingValue(configName));
            });

            var storageAccount = CloudStorageAccount.FromConfigurationSetting("DataConnectionString");

            CloudBlobClient blobClient = storageAccount.CreateCloudBlobClient();
            CloudBlobContainer blobContainer = blobClient.GetContainerReference("pictures");

            blobContainer.CreateIfNotExist();

            var permissions = blobContainer.GetPermissions();
            permissions.PublicAccess = BlobContainerPublicAccessType.Container;
            blobContainer.SetPermissions(permissions);

            blobContainer.GetBlockBlobReference(Guid.NewGuid().ToString()).UploadFromStream(uploadFile.FileContent);
         
            bindImages();
        }


        public void bindImages()
        {
            CloudStorageAccount.SetConfigurationSettingPublisher((configName, configSetter) =>
            {
                // Provide the configSetter with the initial value
                configSetter(RoleEnvironment.GetConfigurationSettingValue(configName));
            });


            var storageAccount = CloudStorageAccount.FromConfigurationSetting("DataConnectionString");

            CloudBlobClient blobStorage = storageAccount.CreateCloudBlobClient();
            CloudBlobContainer blobContainer = blobStorage.GetContainerReference("pictures");

            blobContainer.CreateIfNotExist();

            images.DataSource = from blob in blobContainer.ListBlobs()
                                select new { Url = blob.Uri };
            images.DataBind();
        }

      

    }
}