﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.StorageClient;
using Microsoft.WindowsAzure.ServiceRuntime;

namespace Chapter16.QueueTestWebRole
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

            cmdAddToQueue.Click += new EventHandler(cmdAddToQueue_Click);
            cmdShowQueue.Click += new EventHandler(cmdShowQueue_Click);
     
        }

        void cmdShowQueue_Click(object sender, EventArgs e)
        {

            CloudStorageAccount.SetConfigurationSettingPublisher((configName, configSetter) =>
            {
                // Provide the configSetter with the initial value
                configSetter(RoleEnvironment.GetConfigurationSettingValue(configName));
            });


            var storageAccount = CloudStorageAccount.FromConfigurationSetting("DataConnectionString");

            CloudQueueClient queueStorage = storageAccount.CreateCloudQueueClient();
            CloudQueue queue = queueStorage.GetQueueReference("testqueue");
            queue.CreateIfNotExist();

            string queueContents = "";

            while (queue.PeekMessage() != null)
            {
             
                queueContents += queue.GetMessage().AsString + "<BR>";
            }

            litQueueContents.Text = queueContents;

            CloudQueueMessage readMessage = queue.GetMessage();


        }

        void cmdAddToQueue_Click(object sender, EventArgs e)
        {

            CloudStorageAccount.SetConfigurationSettingPublisher((configName, configSetter) =>
            {
                // Provide the configSetter with the initial value
                configSetter(RoleEnvironment.GetConfigurationSettingValue(configName));
            });

            var storageAccount = CloudStorageAccount.FromConfigurationSetting("DataConnectionString");

            CloudQueueClient queueStorage = storageAccount.CreateCloudQueueClient();
            CloudQueue queue = queueStorage.GetQueueReference("testqueue");
            queue.CreateIfNotExist();

            CloudQueueMessage message = new CloudQueueMessage(txtMessage.Text);
            queue.AddMessage(message);

            txtMessage.Text = "";

        }
    }
}